﻿Partial Public Class WizardPage3
    Inherits PageFunction(Of WizardData)

    Private m_WizardData As WizardData

    ' Save the WizardData object.
    Public Sub New(ByVal wizard_data As WizardData)
        InitializeComponent()

        m_WizardData = wizard_data
    End Sub

#Region "Navigation"
    ' Finish.
    Public Sub btnFinish_Click() Handles btnFinish.Click
        m_WizardData.Canceled = False
        OnReturn(New ReturnEventArgs(Of WizardData)(m_WizardData))
    End Sub

    ' Return a result indicating that we canceled.
    Private Sub btnCancel_Click() Handles btnCancel.Click
        m_WizardData.Canceled = True
        OnReturn(New ReturnEventArgs(Of WizardData)(m_WizardData))
    End Sub

    ' Go back to the previous page.
    Private Sub btnPrev_Click() Handles btnPrev.Click
        NavigationService.GoBack()
    End Sub
#End Region ' Navigation

#Region "Record Selections"
    ' Save the selection.
    Private Sub cboDessert_SelectionChanged() Handles cboDessert.SelectionChanged
        Select Case cboDessert.SelectedIndex
            Case 0
                m_WizardData.Dessert = DessertType.None
            Case 1
                m_WizardData.Dessert = DessertType.IceCream
            Case 2
                m_WizardData.Dessert = DessertType.Cake
            Case 3
                m_WizardData.Dessert = DessertType.Pie
            Case 4
                m_WizardData.Dessert = DessertType.Cookie
            Case Else
                Debug.Assert(False, "Unexpected dessert selection " & cboDessert.SelectedIndex)
        End Select
    End Sub
#End Region ' Record Selections

End Class
