﻿Imports System.Drawing.Drawing2D

Public Class Form1
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.SmoothingMode = SmoothingMode.AntiAlias

        ' Scale by a factor of 30.
        e.Graphics.ScaleTransform(30, 30, MatrixOrder.Append)
        DrawArrow(e.Graphics, HatchStyle.Horizontal)

        ' Translate 150 horizontally and 60 vertically.
        e.Graphics.TranslateTransform(150, 60, MatrixOrder.Append)
        DrawArrow(e.Graphics, HatchStyle.Vertical)

        ' Rotate 30 degrees.
        e.Graphics.RotateTransform(30, MatrixOrder.Append)
        DrawArrow(e.Graphics, HatchStyle.Cross)
    End Sub

    ' Draw an arrow outline.
    Private Sub DrawArrow(ByVal gr As Graphics, ByVal hatch_style As HatchStyle)
        Dim pts() As Point = {
            New Point(0, 1),
            New Point(2, 1),
            New Point(2, 0),
            New Point(4, 2),
            New Point(2, 4),
            New Point(2, 3),
            New Point(0, 3)
        }
        Using hatch_brush As New HatchBrush(hatch_style, Color.Black, Color.White)
            gr.FillPolygon(hatch_brush, pts)
        End Using

        Using black_pen As New Pen(Color.Black, 0)
            gr.DrawPolygon(black_pen, pts)
        End Using
    End Sub
End Class
