﻿Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ShowAllSettings()
    End Sub

    ' Fetch a setting.
    Private Sub btnGet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGet.Click
        txtSettingValue.Text = GetSetting(
            Application.ProductName,
            "Config",
            txtSettingName.Text,
            "<Nothing>")
        ShowAllSettings()

        txtSettingName.Focus()
    End Sub

    ' Save a setting.
    Private Sub btnSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSet.Click
        SaveSetting(
            Application.ProductName,
            "Config",
            txtSettingName.Text,
            txtSettingValue.Text)
        ShowAllSettings()

        txtSettingName.Clear()
        txtSettingValue.Clear()
        txtSettingName.Focus()
    End Sub

    ' Display all of the Config registry settings.
    Private Sub ShowAllSettings()
        lvSettings.Items.Clear()

        Dim settings(,) As String = GetAllSettings(
            Application.ProductName, "Config")
        If settings IsNot Nothing Then
            For i As Integer = 0 To settings.GetUpperBound(0)
                Dim new_item As ListViewItem = lvSettings.Items.Add(settings(i, 0))
                new_item.SubItems.Add(settings(i, 1))
            Next i
        End If
        lvSettings.Columns(0).Width = -2
        lvSettings.Columns(1).Width = -2
    End Sub

    ' Delete a setting.
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        DeleteSetting(Application.ProductName,
            "Config",
            txtSettingName.Text)
        ShowAllSettings()
    End Sub

    ' Display the selected setting's name in the setting text box.
    Private Sub lvSettings_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvSettings.SelectedIndexChanged
        txtSettingName.Clear()
        txtSettingValue.Clear()

        If lvSettings.SelectedItems.Count > 0 Then
            txtSettingName.Text = lvSettings.SelectedItems(0).Text
        End If
    End Sub
End Class
