﻿Imports System.Threading.Tasks

Public Class Form1
    Private Class FiboInfo
        Public N As Long
        Public Result As Long
    End Class

    ' Execute the tasks sequentially.
    Private Sub btnSequential_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSequential.Click
        lblResult0.Text = ""
        lblResult1.Text = ""
        lblResult2.Text = ""
        lblResult3.Text = ""
        lblTimeSequential.Text = ""
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        Dim fibo_info() As FiboInfo = {
            New FiboInfo() With {.N = CLng(txtNum0.Text)},
            New FiboInfo() With {.N = CLng(txtNum1.Text)},
            New FiboInfo() With {.N = CLng(txtNum2.Text)},
            New FiboInfo() With {.N = CLng(txtNum3.Text)}
        }

        Dim start_time As Date = Now

        For i As Long = 0 To 3
            FindFibonacci(fibo_info(i))
        Next i

        lblResult0.Text = fibo_info(0).Result
        lblResult1.Text = fibo_info(1).Result
        lblResult2.Text = fibo_info(2).Result
        lblResult3.Text = fibo_info(3).Result
        Me.Refresh()

        Dim stop_time As Date = Now
        Dim elapsed As TimeSpan = stop_time.Subtract(start_time)
        lblTimeSequential.Text = elapsed.TotalSeconds.ToString("0.00 sec")
        Me.Cursor = Cursors.Default
    End Sub

    ' Execute the tasks in parallel.
    Private Sub btnParallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnParallel.Click
        lblResult0.Text = ""
        lblResult1.Text = ""
        lblResult2.Text = ""
        lblResult3.Text = ""
        lblTimeParallel.Text = ""
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        Dim fibo_info() As FiboInfo = {
            New FiboInfo() With {.N = CLng(txtNum0.Text)},
            New FiboInfo() With {.N = CLng(txtNum1.Text)},
            New FiboInfo() With {.N = CLng(txtNum2.Text)},
            New FiboInfo() With {.N = CLng(txtNum3.Text)}
        }

        Dim start_time As Date = Now

        Parallel.ForEach(fibo_info, AddressOf FindFibonacci)

        lblResult0.Text = fibo_info(0).Result
        lblResult1.Text = fibo_info(1).Result
        lblResult2.Text = fibo_info(2).Result
        lblResult3.Text = fibo_info(3).Result

        Dim stop_time As Date = Now
        Dim elapsed As TimeSpan = stop_time.Subtract(start_time)
        lblTimeParallel.Text = elapsed.TotalSeconds.ToString("0.00 sec")
        Me.Cursor = Cursors.Default
    End Sub

    ' Return the Nth Fibonacci number calculated with recursion.
    Private Function Fibonacci(ByVal N As Long) As Long
        If N <= 1 Then Return 1

        Return Fibonacci(N - 1) + Fibonacci(N - 2)
    End Function

    ' Calculate the Fibonacci number for the
    ' indicated number and save the result.
    Private Sub FindFibonacci(ByVal fibo_info As FiboInfo)
        fibo_info.Result = Fibonacci(fibo_info.N)
    End Sub
End Class
